/* Copyright (C) 2001 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   The author may be contacted at <pfaffben@msu.edu> on the Internet,
   or as Ben Pfaff, 12167 Airport Rd, DeWitt MI 48820, USA through
   more mundane means.  
*/

#ifndef test_h
#define test_h 1

extern const char *pgm_name;

unsigned time_seed (void);
void fail (const char *, ...);
int stoi (const char *s);

/* Describes a command-line option of the form `key[=value]'. */
struct long_option
  {
    const char *key;		/* Key. */
    int takes_value;		/* Takes a (mandatory) value? */
    int id;			/* Identifier returned by option_get(). */
  };
    
/* State of the option parser. */
struct option_state
  {
    /* Parsing state. */
    char **arg_next;		/* Remaining arguments. */
    char *short_next;		/* When non-null, unparsed short options. */

    /* Options. */
    const char *short_opts;	/* Allowed short options. */
    const struct long_option *long_opts; /* Allowed long options. */
  };

void option_init (struct option_state *state, char **args,
		  const char *short_opts, const struct long_option *long_opts);
int option_get (struct option_state *state, char **arg);


#endif /* test.h */
